// <script>

// Copyright (C) 2005 Ilya S. Lyubinskiy. All rights reserved.
// Technical support: http://www.php-development.ru/
//
// YOU MAY NOT
// (1) Remove or modify this copyright notice.
// (2) Distribute this code, any part or any modified version of it.
//     Instead, you can link to the homepage of this code:
//     http://www.php-development.ru/javascripts/dropdown.php.
//
// YOU MAY
// (1) Use this code on your website.
// (2) Use this code as a part of another product provided that
//     its main use is not creating javascript menus.
//
// NO WARRANTY
// This code is provided "as is" without warranty of any kind, either
// expressed or implied, including, but not limited to, the implied warranties
// of merchantability and fitness for a particular purpose. You expressly
// acknowledge and agree that use of this code is at your own risk.

// ***** Popup Control *********************************************************

function at_display(x)
{
  var win = window.open();
  for (var i in x) win.document.write(i+' = '+x[i]+'<br>');
}

// ***** Show Aux *****

function at_show_aux(parent, child)
{
  var p = document.getElementById(parent);
  var c = document.getElementById(child );

  //Up     = 1
  //Down   = 2
  //Right  = 3
  //Left   = 4
  
  //alert("p.offsetLeft = "+p.offsetLeft);
  //alert("p.offsetWidth = "+p.offsetWidth);
  
  var top = 0;
  var left = 0;
  if(c["at_position"] == "5")
    top = p.offsetTop - c.offsetHeight;
  else if(c["at_position"] == "6")
    top = p.offsetTop + p.offsetHeight;
  if(c["at_position"] == "7")
    left = p.offsetLeft + p.offsetWidth;
  else if(c["at_position"] == "8")
    left = p.offsetLeft - c.offsetWidth;
  
  //alert("left1 = "+left);
  
  if(c["at_position"] == "5" || c["at_position"] == "6")
    left += p.offsetLeft;
  
  if(c["at_position"] == "7" || c["at_position"] == "8")
    top  += p.offsetTop;
    
  //alert("left2 = "+left);
       
  c.style.position   = "absolute";
  c.style.top        = top +'px';
  c.style.left       = left +'px';
  c.style.visibility = "visible";
}

// ***** Show *****

function at_show()
{
  var p = document.getElementById(this["at_parent"]);
  var c = document.getElementById(this["at_child" ]);

  at_show_aux(p.id, c.id);

  clearTimeout(c["at_timeout"]);
}

// ***** Hide *****

function at_hide()
{
  var c = document.getElementById(this["at_child"]);

  c["at_timeout"] = setTimeout("document.getElementById('"+c.id+"').style.visibility = 'hidden'", System.Gadget.Settings.readString("DropdownTimeout"));
}

// ***** Click *****

function at_click()
{
  var p = document.getElementById(this["at_parent"]);
  var c = document.getElementById(this["at_child" ]);

  if (c.style.visibility != "visible")
       at_show_aux(p.id, c.id);
  else c.style.visibility = "hidden";

  return false;
}

// ***** Attach *****

// PARAMETERS:
// parent   - id of visible html element
// child    - id of invisible html element that will be dropdowned
// showtype - "click" = you should click the parent to show/hide the child
//            "hover" = you should place the mouse over the parent to show
//                      the child
// position - "x" = the child is displayed to the right of the parent
//            "y" = the child is displayed below the parent
// cursor   - Omit to use default cursor or check any CSS manual for possible
//            values of this field

function at_attach(parentElement, childElement, showtype, position, cursor)
{
  var p = parentElement;
  var c = childElement;

  p["at_parent"]     = p.id;
  c["at_parent"]     = p.id;
  p["at_child"]      = c.id;
  c["at_child"]      = c.id;
  p["at_position"]   = position;
  c["at_position"]   = position;

  c.style.position   = "absolute";
  c.style.visibility = "hidden";

  if (cursor != undefined) p.style.cursor = cursor;

  switch (showtype)
  {
    case "click":
      p.onclick     = at_click;
      p.onmouseout  = at_hide;
      c.onmouseover = at_show;
      c.onmouseout  = at_hide;
      break;
    case "hover":
      p.onmouseover = at_show;
      p.onmouseout  = at_hide;
      c.onmouseover = at_show;
      c.onmouseout  = at_hide;
      break;
  }
}
